# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import osv, fields

class res_company(osv.osv):
    """
        New account configuration fields on company form
    """
    _inherit = 'res.company'
    _columns = {
        'purchase_discount_account': fields.many2one('account.account', 'Purchase Discount Account', domain=[('type', '!=', 'view'),
                                                                                                             ('type', '!=', 'consolidation')]),
        'sales_discount_account': fields.many2one('account.account', 'Sales Discount Account', domain=[('type', '!=', 'view'),
                                                                                                       ('type', '!=', 'consolidation')]),
        'purchase_discount_journal': fields.many2one('account.journal', 'Purchase Discount Journal', domain=[('type', '=', 'purchase')]),
        'sales_discount_journal': fields.many2one('account.journal', 'Sales Discount Journal', domain=[('type', '=', 'sale')]),
        }

res_company()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
