# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import fields, osv

class sale_order(osv.osv):
    _inherit="sale.order"
    
    def action_ship_create(self, cr, uid, ids, *args):
        result = super(sale_order, self).action_ship_create(cr, uid, ids, *args)
        if result:
            for sale in self.browse(cr, uid, ids):
                pick_obj = self.pool.get('stock.picking')
                if sale.ship_company_code == 'ups':
                    pick_ids = pick_obj.search(cr, uid, [('sale_id', '=', sale.id), ('type', '=', 'out')])
                    if pick_ids:
                        vals = {
                            'ship_company_code': 'ups',
                            'logis_company': sale.logis_company and sale.logis_company.id or False,
                            'shipper': sale.ups_shipper_id and sale.ups_shipper_id.id or False,
                            'ups_service': sale.ups_service_id and sale.ups_service_id.id or False,
                            'ups_pickup_type': sale.ups_pickup_type,
                            'ups_packaging_type': sale.ups_packaging_type and sale.ups_packaging_type.id or False
                            }
                        pick_obj.write(cr, uid, pick_ids, vals)
                else:
                    pick_ids = pick_obj.search(cr, uid, [('sale_id', '=', sale.id), ('type', '=', 'out')])
                    if pick_ids:
                        pick_obj.write(cr, uid, pick_ids, {'shipper': False, 'ups_service': False}, context=None)
        return result
    
    def _get_company_code(self, cr, user, context=None):
        res =  super(sale_order, self)._get_company_code(cr, user, context=context)
        res.append(('ups', 'UPS'))
        return res
    
    _columns= {
        'payment_method':fields.selection([
            ('cc_pre_auth', 'Credit Card – PreAuthorized'),
            ('invoice', 'Invoice'),
            ('cod', 'COD'),
            ('p_i_a', 'Pay In Advance'),
            ('pay_pal', 'Paypal'),
            ('no_charge', 'No Charge')], 'Payment Method'),
        'ship_company_code': fields.selection(_get_company_code, 'Ship Company', method=True, size=64),
        'ups_shipper_id': fields.many2one('ups.account.shipping', 'Shipper'),
        'ups_service_id': fields.many2one('ups.shipping.service.type', 'Service Type'),
        'ups_pickup_type': fields.selection([
            ('01', 'Daily Pickup'),
            ('03', 'Customer Counter'),
            ('06', 'One Time Pickup'),
            ('07', 'On Call Air'),
            ('11', 'Suggested Retail Rates'),
            ('19', 'Letter Center'),
            ('20', 'Air Service Center'),
            ],'Pickup Type'),
        'ups_packaging_type': fields.many2one('shipping.package.type','Packaging Type')
    }
    
sale_order()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
