# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################


from osv import fields,osv
from xml.dom.minidom import Document
from tools.translate import _
import httplib
import xml2dic
import base64
import time
import datetime
from urlparse import urlparse
import Image
import tempfile
import re

from mako.template import Template
from mako import exceptions
import netsvc
import base64
import logging
import tools

pack_type={'01' : 'UPS Letter',
'02' : 'Customer Supplied Package',
'03' : 'Tube',
'04' : 'PAK',
'21' : 'UPS ExpressBox',
'24' : 'UPS 25KG Box',
'25' : 'UPS 10KG Box',
'30' : 'Pallet',
'2a' : 'Small Express Box',
'2b' : 'Medium Express Box',
'2c' : 'Large Express Box'}



class shipping_move(osv.osv):
    _inherit = "shipping.move"
    _columns = {

            'shipment_identific_no': fields.char('ShipmentIdentificationNumber', size=64, ),
            'logo':fields.binary('Logo'),
            'tracking_url':fields.char('Tracking URL', size=512, ),
            'service': fields.many2one('ups.shipping.service.type', 'Shipping Service'),

             }
    def print_label(self, cr, uid, ids, context=None):
        if not ids: return []

        return {
            'type': 'ir.actions.report.xml',
            'report_name':'ship.log.label.print',
            'datas': {
                    'model':'shipping.move',
                    'id': ids and ids[0] or False,
                    'ids': ids and ids or [],
                    'report_type': 'pdf'
                },
            'nodestroy': True
            }
    def getTrackingUrl(self,cr, uid, ids, context=None):
        ship_log_obj = self.browse(cr, uid, ids[0], context=context)
        if ship_log_obj.tracking_no:
            tracking_url = """http://wwwapps.ups.com/WebTracking/processInputRequest?sort_by=status&tracknums_displayed=1&TypeOfInquiryNumber=T&loc=en_US&InquiryNumber1=%s&track.x=0&track.y=0""" % ship_log_obj.tracking_no


shipping_move()



class stock_picking(osv.osv):

    _inherit = "stock.picking"
    def _get_company_code(self, cr, user, context=None):
        res =  super(stock_picking, self)._get_company_code(cr, user, context=context)
        res.append(('ups', 'UPS'))
        return res
    _columns={
            'ups_service': fields.many2one('ups.shipping.service.type','Service',help='The specific shipping service offered'),
            'shipper': fields.many2one('ups.account.shipping','Shipper',help='The specific user ID and shipper. Setup in the company configuration.'),
            'shipment_digest': fields.text('ShipmentDigest'),
            'negotiated_rates': fields.float('NegotiatedRates'),
            'shipment_identific_no': fields.char('ShipmentIdentificationNumber', size=64, ),
            'tracking_no': fields.char('TrackingNumber', size=64, ),
            
            'trade_mark': fields.related('shipper','trademark',type='char',size=1024,string='Trademark'),
            'ship_company_code': fields.selection(_get_company_code, 'Ship Company', method=True,  size=64),
             }
    
    def action_process(self, cr, uid, ids, context=None):
        deliv_order = self.browse(cr, uid, type(ids)==type([]) and ids[0] or ids, context=context)
        do_transaction = True
        if deliv_order.sale_id and deliv_order.sale_id.payment_method == 'cc_pre_auth' and not deliv_order.sale_id.invoiced:
            
            rel_voucher_id = deliv_order.sale_id.rel_account_voucher_id and deliv_order.sale_id.rel_account_voucher_id.id or False
            if rel_voucher_id and deliv_order.sale_id.rel_account_voucher_id.state != 'posted' and deliv_order.sale_id.rel_account_voucher_id.cc_auth_code:
                do_transaction = False
                self.pool.get('account.voucher').write(cr,uid,[rel_voucher_id],{'cc_p_authorize':False,'cc_charge':True})
                do_transaction = self.pool.get('account.voucher').authorize(cr, uid, [rel_voucher_id], context=context)
        if  not do_transaction:
            self.write(cr,uid,ids,{'ship_state':'hold','ship_message':'Unable to process creditcard payment.'})
            cr.commit()
            raise osv.except_osv(_('Final credit card charge cannot be completed!'),_("Please hold shipment and contact customer service..") )
        return super(stock_picking, self).action_process(cr, uid, ids, context=context)
    
    def action_done(self, cr, uid, ids, context=None):

        res = super(stock_picking, self).action_done(cr, uid, ids, context=context)
        if ids:
            for stock_pick_obj in self.pool.get('stock.picking').browse(cr,uid,ids):
                vals={}
                if stock_pick_obj.sale_id:
                    if stock_pick_obj.sale_id.ship_method:
                        ups_shipping_service_type_ids=self.pool.get('ups.shipping.service.type').search(cr,uid,[('description','like',stock_pick_obj.sale_id.ship_method)])
                        if ups_shipping_service_type_ids:
                          vals['ups_service']=ups_shipping_service_type_ids[0]
                          ups_shipping_service_type_obj=self.pool.get('ups.shipping.service.type').browse(cr,uid,ups_shipping_service_type_ids[0])
                          if ups_shipping_service_type_obj.ups_account_id:
                            vals['shipper']=ups_shipping_service_type_obj.ups_account_id.id
                            if ups_shipping_service_type_obj.ups_account_id.logistic_company_id:
                                vals['logis_company']=ups_shipping_service_type_obj.ups_account_id.logistic_company_id.id
                if vals:
                    self.write(cr,uid,ids,vals)
        return True


    def on_change_sale_id(self, cr, uid, ids, sale_id=False, state=False, context=None):
            vals={}
            if sale_id:
                sale_order_obj=self.pool.get('sale.order').browse(cr,uid,sale_id)
                ups_shipping_service_ids=self.pool.get('ups.shipping.service.type').search(cr,uid,[('description','=',sale_order_obj.ship_method)])

                if type(ups_shipping_service_ids)==type([]) and len(ups_shipping_service_ids)>0:
                      vals['ups_service']=ups_shipping_service_ids[0]
                      ups_shipping_account_ids=self.pool.get('ups.account.shipping').search(cr,uid,[('ups_shipping_service_ids','in',ups_shipping_service_ids[0])])

                      if type(ups_shipping_account_ids)==type([]) and len(ups_shipping_account_ids)>0:
                        vals['shipper']=ups_shipping_account_ids[0]
                        logistic_company_ids=self.pool.get('logistic.company').search(cr,uid,[('ups_shipping_account_ids','in',ups_shipping_account_ids[0])])

                        if type(logistic_company_ids)==type([]) and len(logistic_company_ids)>0:
                            vals['logis_company']=logistic_company_ids[0]

            return {'value':vals}


    def process_void(self,cr, uid, ids, context=None):
        
        error_flag = False
        if type(ids)==type([]):
            pick_obj=self.pool.get('stock.picking').browse(cr, uid, ids[0])
        else:
            pick_obj=self.pool.get('stock.picking').browse(cr, uid, ids)

        if pick_obj.ship_company_code != 'ups':
            return super(stock_picking, self).process_void(cr, uid, ids, context=context)

###create the acces req xml first
        data_for_Access_Request={
                                    'AccessLicenseNumber':pick_obj.shipper.id and pick_obj.shipper.accesslicensenumber or '',
                                    'UserId':pick_obj.shipper.id and pick_obj.shipper.userid or '',
                                    'Password':pick_obj.shipper.id and pick_obj.shipper.password or ''
                                }
        response = ''
        for pack in pick_obj.packages_ids:

            data_for_void_shipment={'VoidShipmentRequest':{'Request':{
                                                        'RequestAction':"1",
                                                      'TransactionReference':{'CustomerContext':"",},
                                                      },
                                            'ShipmentIdentificationNumber':pick_obj.logis_company.test_mode and '1Z2220060294314162' or pack.shipment_identific_no or '',

                                                'ExpandedVoidShipment':{
                                                                        'ShipmentIdentificationNumber':pick_obj.logis_company.test_mode and  '1Z2220060294314162' or pack.shipment_identific_no or '',
                                                                        'TrackingNumber':pick_obj.logis_company.test_mode and '1Z2220060291994175' or pack.tracking_no or ''
                                                                        }
                                                            }
                                            }


            doc2=Document()
            VoidShipmentRequest = doc2.createElement("VoidShipmentRequest")
            doc2.appendChild(VoidShipmentRequest)

            Request = doc2.createElement("Request")
            VoidShipmentRequest.appendChild(Request)


            RequestAction = doc2.createElement("RequestAction")
            ptext = doc2.createTextNode(data_for_void_shipment["VoidShipmentRequest"]['Request']['RequestAction'])
            RequestAction.appendChild(ptext)
            Request.appendChild(RequestAction)

            TransactionReference = doc2.createElement("TransactionReference")
            Request.appendChild(TransactionReference)

            CustomerContext = doc2.createElement("CustomerContext")
            ptext = doc2.createTextNode(data_for_void_shipment["VoidShipmentRequest"]['Request']['TransactionReference']['CustomerContext'])
            CustomerContext.appendChild(ptext)
            TransactionReference.appendChild(CustomerContext)

            ExpandedVoidShipment = doc2.createElement("ExpandedVoidShipment")
            VoidShipmentRequest.appendChild(ExpandedVoidShipment)

            ShipmentIdentificationNumber = doc2.createElement("ShipmentIdentificationNumber")
            ptext = doc2.createTextNode(data_for_void_shipment["VoidShipmentRequest"]['ExpandedVoidShipment']['ShipmentIdentificationNumber'])
            ShipmentIdentificationNumber.appendChild(ptext)
            ExpandedVoidShipment.appendChild(ShipmentIdentificationNumber)

            TrackingNumber = doc2.createElement("TrackingNumber")
            ptext = doc2.createTextNode(data_for_void_shipment["VoidShipmentRequest"]['ExpandedVoidShipment']['TrackingNumber'])
            TrackingNumber.appendChild(ptext)
            ExpandedVoidShipment.appendChild(TrackingNumber)

            Request_string2=doc2.toprettyxml()


            doc1 = Document()
            AccessRequest = doc1.createElement("AccessRequest")
            AccessRequest.setAttribute("xml:lang", "en-US")
            doc1.appendChild(AccessRequest)

            AccessLicenseNumber = doc1.createElement("AccessLicenseNumber")
            ptext = doc1.createTextNode(data_for_Access_Request["AccessLicenseNumber"])
            AccessLicenseNumber.appendChild(ptext)
            AccessRequest.appendChild(AccessLicenseNumber)

            UserId = doc1.createElement("UserId")
            ptext = doc1.createTextNode(data_for_Access_Request["UserId"])
            UserId.appendChild(ptext)
            AccessRequest.appendChild(UserId)

            Password = doc1.createElement("Password")
            ptext = doc1.createTextNode(data_for_Access_Request["Password"])
            Password.appendChild(ptext)
            AccessRequest.appendChild(Password)

            Request_string1=doc1.toprettyxml()

            Request_string=Request_string1+Request_string2

            
            if pick_obj.logis_company.test_mode:
                void_web = pick_obj.logis_company.ship_void_test_web or ''
                void_port = pick_obj.logis_company.ship_void_test_port
            else:
                void_web = pick_obj.logis_company.ship_void_web or ''
                void_port = pick_obj.logis_company.ship_void_port
            if void_web:
                parse_url = urlparse(void_web)
                serv = parse_url.netloc
                serv_path = parse_url.path
            else:
                raise osv.except_osv(_('Unable to find Shipping URL!'),_("Please configure the shipping company with websites.") )
            
            conn=httplib.HTTPSConnection(serv,void_port)
            filename="/tmp/void_request_" + pick_obj.name.replace('/','') + '.xml'
            f = open(filename, 'w')
            f.write(Request_string)
            f.close
            res=conn.request("POST",serv_path,Request_string)
            res=conn.getresponse()
            result = res.read()
            filename="/tmp/void_response_" + pick_obj.name.replace('/','') + '.xml'
            f = open(filename, 'w')
            f.write(result)
            f.close

            response_dic=xml2dic.main(result)
            response = ''
            error_flag=False
            for elm in response_dic['VoidShipmentResponse'][0]['Response']:
                if 'ResponseStatusCode' in elm.keys():
                    response += 'ResponseStatusCode:'+str(elm['ResponseStatusCode'])+'\n'
                if 'ResponseStatusDescription' in elm.keys():
                    response += 'ResponseStatusDescription:'+str(elm['ResponseStatusDescription'])+'\n'
                if 'Error' in elm.keys():
                    error_flag = True
                    response += 'Error:'+str(elm['Error'])+'\n'


            response = 'Void:\n'+response
            self.pool.get('stock.packages').write(cr,uid,pack.id,{'ship_message':str(response)})

        if not error_flag:
            clear_vals={
                            'ship_message': '',
                            'negotiated_rates' : 0.00,
                            'shipment_identific_no' :'',
                            'tracking_no': '',
                            'tracking_url': '',
                            'logo' : '',
                            'control_log_receipt':''
                        }
            for package in pick_obj.packages_ids:
                self.pool.get('stock.packages').write(cr, uid, package.id, clear_vals, context=context)
            self.pool.get('stock.picking').write(cr, uid, ids,{'ship_state':'draft','ship_message':'Shipment has been cancelled.'})
        else:
            self.pool.get('stock.picking').write(cr, uid, ids,{'ship_message':response})
        return True


    def get_package(self,pack_obj):
        if not pack_obj:
            return []
        else:
            ret = []
            ret.append({
                'Description':"",'PackagingType':{'Code':pack_obj.package_type or "",'Description':pack_type.get(pack_obj.package_type , "")},#PackagingType
                        'Dimensions':{'UnitOfMeasurement':{'Code':"IN",'Description':"Inches"},'Length':str(pack_obj.length or "0"),'Width':str(pack_obj.width or "0"),'Height':str(pack_obj.height or "0")},#Dimensions
                        'PackageWeight':{'UnitOfMeasurement':{'Code':"LBS",'Description':"Pounds"},'Weight':str(pack_obj.weight or "0")},
                        'ReferenceNumber':{'BarCodeIndicator':"",'Code':pack_obj.ref1 or "",'Value':""},
                            'PackageServiceOptions':{#'DeliveryConfirmation':{'DCISType':"",'DCISNumber':""},#DeliveryConfirmation
                                        'InsuredValue':{#'Type':"",'Code':"",'Description':"",
                                                'MonetaryValue':str(pack_obj.decl_val),
                                                
                                         },#InsuredValue
                        }#PackageServiceOptions
                })
            return ret

    def fill_addr(self,addr_id):
        ret = {'AddressLine1':addr_id and addr_id.street or '',
             'AddressLine2':addr_id and addr_id.street2 or '',
             'AddressLine3':"",
            'City':addr_id and addr_id.city or '',
            'StateProvinceCode':addr_id and addr_id.state_id.id and addr_id.state_id.code or '',
            'PostalCode':addr_id and addr_id.zip or '',
            'CountryCode':addr_id and addr_id.country_id.id and addr_id.country_id.code or '',
            }
        if addr_id and addr_id.classification=='2':
            ret.update({'ResidentialAddress': ""})

        if addr_id and ('zip_id' in addr_id._columns.keys()):
            ret['PostalCode'] = addr_id.zip_id.id and str(addr_id.zip_id.zipcode) or ''
        return ret

    def create_ship_accept_request(self,cr, uid, ids,package_id):
        package_obj=self.pool.get('stock.packages').browse(cr, uid, package_id)

###create the acces req xml first
        data_for_Access_Request={
                                    'AccessLicenseNumber':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.accesslicensenumber or '',
                                    'UserId':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.userid or '',
                                    'Password':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.password or ''
                                }

        doc1 = Document()
        AccessRequest = doc1.createElement("AccessRequest")
        AccessRequest.setAttribute("xml:lang", "en-US")
        doc1.appendChild(AccessRequest)

        AccessLicenseNumber = doc1.createElement("AccessLicenseNumber")
        ptext = doc1.createTextNode(data_for_Access_Request["AccessLicenseNumber"])
        AccessLicenseNumber.appendChild(ptext)
        AccessRequest.appendChild(AccessLicenseNumber)

        UserId = doc1.createElement("UserId")
        ptext = doc1.createTextNode(data_for_Access_Request["UserId"])
        UserId.appendChild(ptext)
        AccessRequest.appendChild(UserId)

        Password = doc1.createElement("Password")
        ptext = doc1.createTextNode(data_for_Access_Request["Password"])
        Password.appendChild(ptext)
        AccessRequest.appendChild(Password)

        Request_string1=doc1.toprettyxml()

        data_for_Ship_Accept = {'ShipmentAcceptRequest':{
                                                        'Request':{
                                                                  'RequestAction':'ShipAccept',
                                                                  'TransactionReference':{'CustomerContext':''}
                                                                  },
                                                        'ShipmentDigest':package_obj.shipment_digest
                                                        }
                                    }


        doc2 = Document()
        ShipmentAcceptRequest = doc2.createElement("ShipmentAcceptRequest")
        ShipmentAcceptRequest.setAttribute("xml:lang", "en-US")
        doc2.appendChild(ShipmentAcceptRequest)

        Request = doc2.createElement("Request")
        ShipmentAcceptRequest.appendChild(Request)

        RequestAction = doc2.createElement("RequestAction")
        ptext = doc1.createTextNode(data_for_Ship_Accept['ShipmentAcceptRequest']["Request"]['RequestAction'])
        RequestAction.appendChild(ptext)
        Request.appendChild(RequestAction)

        TransactionReference = doc2.createElement("TransactionReference")
        Request.appendChild(TransactionReference)

        CustomerContext = doc2.createElement("CustomerContext")
        ptext = doc1.createTextNode(data_for_Ship_Accept['ShipmentAcceptRequest']["Request"]['TransactionReference']['CustomerContext'])
        CustomerContext.appendChild(ptext)
        TransactionReference.appendChild(CustomerContext)

        ShipmentDigest = doc2.createElement("ShipmentDigest")
        ptext = doc1.createTextNode(data_for_Ship_Accept['ShipmentAcceptRequest']["ShipmentDigest"])
        ShipmentDigest.appendChild(ptext)
        ShipmentAcceptRequest.appendChild(ShipmentDigest)

        Request_string2=doc2.toprettyxml()
        request_string=Request_string1+Request_string2

        return request_string

    def process_ship_accept(self,cr, uid, ids,ship_move_ids,pack_obj,context=None):


        shipment_accept_request_xml=self.create_ship_accept_request(cr, uid, ids,pack_obj.id)

        if pack_obj.pick_id.logis_company.test_mode:
            acce_web = pack_obj.pick_id.logis_company.ship_accpt_test_web or ''
            acce_port = pack_obj.pick_id.logis_company.ship_accpt_test_port
        else:
            acce_web = pack_obj.pick_id.logis_company.ship_accpt_web or ''
            acce_port = pack_obj.pick_id.logis_company.ship_accpt_port
        if acce_web:
            parse_url = urlparse(acce_web)
            serv = parse_url.netloc
            serv_path = parse_url.path
        else:
            raise osv.except_osv(_('Unable to find Shipping URL!'),_("Please configure the shipping company with websites.") )



        conn=httplib.HTTPSConnection(serv,acce_port)
        filename="/tmp/ship_accept_request_" + pack_obj.pick_id.name.replace('/','') + '.xml'
        f = open(filename, 'w')
        f.write(shipment_accept_request_xml)
        f.close
        res=conn.request("POST",serv_path,shipment_accept_request_xml)
        res=conn.getresponse()
        
        result = res.read()
        filename="/tmp/ship_accept_response_" + pack_obj.pick_id.name.replace('/','') + '.xml'
        f = open(filename, 'w')        
        f.write(result)
        f.close

        response_dic=xml2dic.main(result)
        NegotiatedRates=''
        ShipmentIdentificationNumber=''
        TrackingNumber=''
        label_image=''
        control_log_image=''
        if response_dic['ShipmentAcceptResponse'][0]['Response'][0]['ResponseStatusCode'] == '1':
            if len(response_dic['ShipmentAcceptResponse'])>1 and response_dic['ShipmentAcceptResponse'][1].has_key('ShipmentResults'):
                if len(response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'])>1 and response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][1].has_key('NegotiatedRates'):
                    if  len(response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][1]['NegotiatedRates'])>0 and response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][1]['NegotiatedRates'][0].has_key('NetSummaryCharges'):
                        if len(response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][1]['NegotiatedRates'][0]['NetSummaryCharges'])>0 and response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][1]['NegotiatedRates'][0]['NetSummaryCharges'][0].has_key('GrandTotal'):
                           NegotiatedRates=response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][1]['NegotiatedRates'][0]['NetSummaryCharges'][0]['GrandTotal'][1]['MonetaryValue']

                if len(response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'])>0 and response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][3].has_key('ShipmentIdentificationNumber'):
                    ShipmentIdentificationNumber=response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][3]['ShipmentIdentificationNumber']

                if len(response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'])>4 and response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][4].has_key('PackageResults') :
                    if len(response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][4]['PackageResults'])>0:
                        TrackingNumber=response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][4]['PackageResults'][0]['TrackingNumber']

                    if len(response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][4]['PackageResults'])>2 and response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][4]['PackageResults'][2].has_key('LabelImage') :
                        label_image =response_dic['ShipmentAcceptResponse'][1]['ShipmentResults'][4]['PackageResults'][2]['LabelImage'][1]['GraphicImage']
                
                
                for item in response_dic['ShipmentAcceptResponse'][1]['ShipmentResults']:
                    if item.has_key('ControlLogReceipt'):
                        for i in item:
                            for j in item['ControlLogReceipt']:
                                if j.get('GraphicImage'):
                                    control_log_image = j['GraphicImage']
                
        if TrackingNumber:
            tracking_url = pack_obj.pick_id.logis_company.ship_tracking_url
            if tracking_url:
                try:
                    tracking_url = tracking_url%TrackingNumber
                except Exception, e:
                    tracking_url = "Invalid tracking url on shipping company"
        else:
            tracking_url = ''
        if label_image:
            im_in_raw=base64.decodestring(label_image)
            path=tempfile.mktemp()
            temp=file(path,'wb')
            temp.write(im_in_raw)
            temp.close()
            new_im=Image.open(path)
            new_im=new_im.rotate(270)
            
            filename="/tmp/label_" + pack_obj.pick_id.name.replace('/','') + '.gif'
            f = open(filename, 'w')
            f.close
            
            new_im.save(filename,'GIF')
            
            label_from_file=open(filename,'rb')
            label_image=base64.encodestring(label_from_file.read())
            label_from_file.close()

        if control_log_image:
            print "contrlo log image : ", control_log_image
            im_in_raw=base64.decodestring(control_log_image)
            
            path= '/tmp/control_log.html'
            temp=file(path,'wb')
            temp.write(im_in_raw)
            temp.close()
            
            label_from_file=open(path,'rb')
            control_log_image=base64.encodestring(label_from_file.read())
            label_from_file.close()
            
        self.pool.get('stock.packages').write(cr,uid,[pack_obj.id],{'tracking_no':TrackingNumber or "",
                                                                     'shipment_identific_no':ShipmentIdentificationNumber or "",
                                                                     'negotiated_rates':NegotiatedRates or '',
                                                                     'logo':label_image,
                                                                     'control_log_receipt' : control_log_image,
                                                                     'ship_state':'in_process',
                                                                     'tracking_url':tracking_url})

        if ship_move_ids.get(pack_obj.id):
            if TrackingNumber:
                tracking_url = pack_obj.pick_id.logis_company.ship_tracking_url
                if tracking_url:
                    try:
                        tracking_url = tracking_url%TrackingNumber
                    except Exception, e:
                        tracking_url = "Invalid tracking url on shipping company"
            else:
                tracking_url = ''
            self.pool.get('shipping.move').write(cr, uid, [ship_move_ids.get(pack_obj.id)], {'tracking_no':TrackingNumber or "",
                                                                     'shipment_identific_no':ShipmentIdentificationNumber or "",
                                                                     'ship_cost':NegotiatedRates or '',
                                                                     'logo':label_image,
                                                                     'state':'ready_pick',
                                                                     'tracking_url':tracking_url})
        return True

    def add_product(self, cr, uid, package_obj):
        prods = []
        tot_weight = 0
        for pkg in package_obj.pick_id.packages_ids:
            tot_weight += pkg.weight
        for move_lines in package_obj.pick_id.move_lines:
            product_id = move_lines.product_id
            if move_lines.product_id.supply_method == 'produce':
                produce = "Yes"
            else:
                produce = "NO[1]" 
            product={'Description':move_lines.product_id.description or " ",
                     'Unit':{'Number':str(int(move_lines.product_qty) or 0),
                             'Value':str((move_lines.product_id.list_price * move_lines.product_qty) or 0),
                             'UnitOfMeasurement':{'Code':"LBS",'Description':"Pounds"}
                            },
             'CommodityCode':package_obj.pick_id.comm_code or "",
             'PartNumber':"",
             'OriginCountryCode':package_obj.pick_id.address_id and package_obj.pick_id.address_id.country_id and package_obj.pick_id.address_id.country_id.code or "",
             'JointProductionIndicator':"",
             'NetCostCode':"NO",
             'PreferenceCriteria':"B",
             'ProducerInfo':produce,
             'MarksAndNumbers':"",
             'NumberOfPackagesPerCommodity':str(len(package_obj.pick_id.packages_ids)),
             'ProductWeight':{'UnitOfMeasurement':{'Code':"LBS",'Description':"Pounds"},
                               'Weight':"%.1f"%(tot_weight or '0')},
             'VehicleID':"",
                }
            prods.append(product)
        return prods

    def create_comm_inv(self, cr, uid, package_obj):
        invoice_id = False
        if package_obj.pick_id.sale_id:
            if package_obj.pick_id.sale_id.invoice_ids:
                invoice_id = package_obj.pick_id.sale_id.invoice_ids[0]
        user = self.pool.get('res.users').browse(cr, uid, uid)
        comm_inv={    'FormType':"01",
            'Product':[],#Placed out of this dictionary for common use
            'InvoiceNumber':"",
            'InvoiceDate':"",
            'PurchaseOrderNumber':"",
            'TermsOfShipment':"",
            'ReasonForExport':"SALE",
            'Comments':"",
            'DeclarationStatement':"I hereby certify that the good covered by this shipment qualifies as an originating good for purposes of preferential tariff treatment under the NAFTA.",
            'CurrencyCode':user.company_id.currency_id.name or "",
        }
        if invoice_id:
            comm_inv['InvoiceNumber'] = invoice_id.number or '/'
            if invoice_id.date_invoice:
                d=invoice_id.date_invoice
                comm_inv['InvoiceDate'] = d[:4]+d[5:7]+d[8:10]
        if not comm_inv['InvoiceDate']:
            comm_inv['InvoiceDate'] = time.strftime("%Y%m%d")
        
        return comm_inv

    def create_cer_orig(self, cr, uid, package_obj):
        cer_orig={    
            'FormType':"03",
#            'AdditionalDocumentIndicator':"",                            Not Required
#            'FormGroupIdName':"",                                        Not Required
            'Product':[],#Placed out of this dictionary for common use
            'ExportDate':time.strftime("%Y%m%d"),
            'ExportingCarrier':package_obj.pick_id.exp_carrier or "",
        }
        return cer_orig

    def create_nafta_cer_orig(self, cr, uid, package_obj):
        addr = {}
        if package_obj.pick_id.prod_address_id:
            addr_id = package_obj.pick_id.prod_address_id
            
            addr = {'AddressLine1':addr_id.street or "",
                                  'AddressLine2':addr_id.street2 or "",
                                  'City':addr_id.city or "",
                                  'StateProvinceCode':addr_id.state_id and addr_id.state_id.code or "",
                                  'PostalCode':addr_id.zip or "",
                                  'CountryCode':addr_id.country_id and addr_id.country_id.code or "",
                                  }
        beg_date=" "
        end_date=" "
        if package_obj.pick_id.blanket_begin_date:
            beg_date = package_obj.pick_id.blanket_begin_date
            beg_date = beg_date[:4]+beg_date[5:7]+beg_date[8:10]
        if package_obj.pick_id.blanket_end_date:
            end_date = package_obj.pick_id.blanket_end_date
            end_date = end_date[:4]+end_date[5:7]+end_date[8:10]
        nafta_cer_orig={    'FormType':"04",
             'Contacts':{

                            'Producer':{'Option':package_obj.pick_id.prod_option or "",
                                        'CompanyName':package_obj.pick_id.prod_company or "",
                                        'TaxIdentificationNumber':package_obj.pick_id.prod_tax_id_no or "",
                                        'Address':addr,#Address
                                        },#Producer
                         },#Contacts
             'BlanketPeriod':{
                              'BeginDate':beg_date,
                              'EndDate':end_date,

                              },
             'Product':[],#Placed out of this dictionary for common use
        }
        return nafta_cer_orig
    
    def create_forms(self, cr, uid, package_obj):
        comm_inv = {}
        cer_orig = {}
        nafta_cer_orig = {}
        sed = {}
        if package_obj.pick_id.comm_inv:
            comm_inv = self.create_comm_inv(cr, uid, package_obj)
        if package_obj.pick_id.cer_orig:
            cer_orig = self.create_cer_orig(cr, uid, package_obj)
        if package_obj.pick_id.nafta_cer_orig:
            nafta_cer_orig = self.create_nafta_cer_orig(cr, uid, package_obj)
        prod = self.add_product(cr, uid, package_obj)
        ret = {'comm_inv':comm_inv,'cer_orig':cer_orig,'nafta_cer_orig':nafta_cer_orig,'sed':sed,'prod':prod}
        return ret
    def create_ship_confirm_request(self,cr, uid,package_id):
            package_obj=self.pool.get('stock.packages').browse(cr, uid, package_id)

###create the acces req xml first
            data_for_Access_Request={
                                        'AccessLicenseNumber':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.accesslicensenumber or '',
                                        'UserId':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.userid or '',
                                        'Password':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.password or ''
                                    }

            doc1 = Document()
            AccessRequest = doc1.createElement("AccessRequest")
            AccessRequest.setAttribute("xml:lang", "en-US")
            doc1.appendChild(AccessRequest)

            AccessLicenseNumber = doc1.createElement("AccessLicenseNumber")
            ptext = doc1.createTextNode(data_for_Access_Request["AccessLicenseNumber"])
            AccessLicenseNumber.appendChild(ptext)
            AccessRequest.appendChild(AccessLicenseNumber)

            UserId = doc1.createElement("UserId")
            ptext = doc1.createTextNode(data_for_Access_Request["UserId"])
            UserId.appendChild(ptext)
            AccessRequest.appendChild(UserId)

            Password = doc1.createElement("Password")
            ptext = doc1.createTextNode(data_for_Access_Request["Password"])
            Password.appendChild(ptext)
            AccessRequest.appendChild(Password)

            Request_string1=doc1.toprettyxml()

###create the shipment acces req xml
            data_for_confirm_request={'ShipmentConfirmRequest':{

                                  'Request':{'RequestAction':"ShipConfirm",#-----must be ShipConfirm
                                            'RequestOption':package_obj.pick_id.address_validate or "nonvalidate",#----------adress validation
                                            'TransactionReference':{'CustomerContext':"",},#---------optional data
                                            },#Request

                                  'Shipment':{'Description':package_obj.description or "Shipping",
                                              'ReturnService':{'Code':"8", 'DocumentsOnly':"" },
                                              'Shipper':{ 'Name':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.name or "",
                                                          'AttentionName':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.atten_name or "",
                                                          'ShipperNumber':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.acc_no or "",
                                                          'TaxIdentificationNumber':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.tax_id_no or "",
                                                          'PhoneNumber':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.address and package_obj.pick_id.shipper.address.phone or "",
                                                          'FaxNumber':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.address and package_obj.pick_id.shipper.address.fax or "",
                                                          'EMailAddress':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.address and package_obj.pick_id.shipper.address.email or "",
                                                          'Address':self.fill_addr(package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.address or '')
                                                         },#Shipper

                                              'ShipTo': {'CompanyName':package_obj.pick_id.address_id.partner_id and package_obj.pick_id.address_id.partner_id.name or '',
                                                        'AttentionName':package_obj.pick_id.inv_att_name or "",
                                                        'TaxIdentificationNumber':"",
                                                        'PhoneNumber':package_obj.pick_id.address_id.id and package_obj.pick_id.address_id.phone or '',
                                                        'FaxNumber':package_obj.pick_id.address_id.id and package_obj.pick_id.address_id.fax or '',
                                                        'EMailAddress':package_obj.pick_id.address_id.id and package_obj.pick_id.address_id.email or '',
                                                        'Address':self.fill_addr(package_obj.pick_id.address_id.id and package_obj.pick_id.address_id),
                                                        'LocationID':"",
                                                         },#ShipTo



                                              'ShipFrom':{'CompanyName':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.name or "",
                                                          'AttentionName':package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.atten_name or "",
                                                          'TaxIdentificationNumber':package_obj.pick_id.ship_from_tax_id_no or '',
                                                          'PhoneNumber':package_obj.pick_id.address_id.id and package_obj.pick_id.ship_from_address.phone or '',
                                                          'FaxNumber':package_obj.pick_id.address_id.id and package_obj.pick_id.ship_from_address.fax or '',
                                                          'Address':self.fill_addr(package_obj.pick_id.ship_from_address.id and package_obj.pick_id.ship_from_address),
                                                          },

                                              'SoldTo':{'Option':package_obj.pick_id.inv_option or " ",
                                                        'CompanyName':package_obj.pick_id.inv_company or "",
                                                        'AttentionName':package_obj.pick_id.inv_att_name or "",
                                                        'TaxIdentificationNumber':package_obj.pick_id.inv_tax_id_no or "",
                                                        'PhoneNumber':package_obj.pick_id.inv_address_id and package_obj.pick_id.inv_address_id.phone or "",
                                                        'Address':{'AddressLine1':package_obj.pick_id.inv_address_id and package_obj.pick_id.inv_address_id.street or "",
                                                                   'AddressLine2':package_obj.pick_id.inv_address_id and package_obj.pick_id.inv_address_id.street2 or "",
                                                                   'City':package_obj.pick_id.inv_address_id and package_obj.pick_id.inv_address_id.city or "",
                                                                   'StateProvinceCode':package_obj.pick_id.inv_address_id and package_obj.pick_id.inv_address_id.state_id and package_obj.pick_id.inv_address_id.state_id.code or "",
                                                                   'PostalCode':package_obj.pick_id.inv_address_id and package_obj.pick_id.inv_address_id.zip or "",
                                                                   'CountryCode':package_obj.pick_id.inv_address_id and package_obj.pick_id.inv_address_id.country_id and package_obj.pick_id.inv_address_id.country_id.code or "",}
                                                      },#SoldTo,

                                              'PaymentInformation':{'Prepaid':{
                                                                            'BillShipper':{'AccountNumber':package_obj.pick_id.shipper and package_obj.pick_id.shipper.acc_no or "",
                                                                                            },#BillShipper
                                                                                },#Prepaid
                                                                  },#PaymentInformation,


                                 'GoodsNotInFreeCirculationIndicator':"",
                                 'RateInformation':{'NegotiatedRatesIndicator':""},#RateInformation
                                 'Service':{'Code':package_obj.pick_id.ups_service.id and str(package_obj.pick_id.ups_service.shipping_service_code) or "",
                                            'Description':package_obj.pick_id.ups_service.id and package_obj.pick_id.ups_service.description or ""},#Service
                                 'InvoiceLineTotal':{'CurrencyCode':"",'MonetaryValue':str(int(package_obj.pick_id.sale_id.amount_total or 0.00)) or ""},#InvoiceLineTotal
                                 'ShipmentServiceOptions':{'SaturdayDelivery':"",
                                                           'Notification':[],
                                                           'LabelDelivery':{'LabelLinkIndicator':"",
                                                                            'EMailMessage':{'EMailAddress':"mail@mail.com",
                                                                                           'UndeliverableEMailAddress':"",
                                                                                           'FromEMailAddress':"mail@mail.com",
                                                                                           'FromName':"",
                                                                                           'Memo':"",
                                                                                           'Subject':"",
                                                                                           'SubjectCode':""}#EMailMessage
                                                                            },#LabelDelivery

                                                           'InternationalForms':self.create_forms(cr, uid, package_obj),#InternationalForms
                                                         },#ShipmentServiceOptions,
                                 'Package':self.get_package(package_obj)## this is done in different file
                                                },#Shipment
                'LabelSpecification':{'LabelPrintMethod':{'Code':"GIF", 'Description':"GIF",},
                                      'HTTPUserAgent':"",
                                      'LabelStockSize':{'Height':"6",'Width':"6"},
                                      'LabelImageFormat':{'Code':"GIF",'Description':"GIF"},
                                    },#LabelSpecification

            },#ShipmentConfirmRequest
        }



            print "DATA FOR CONFIR R : \n", data_for_confirm_request
            comm_inv = data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["InternationalForms"]['comm_inv']
            cer_orig = data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["InternationalForms"]['cer_orig']
            nafta_cer_orig = data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["InternationalForms"]['nafta_cer_orig']
            sed = False #data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["InternationalForms"]['sed']
            prod = data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["InternationalForms"]['prod']
            

            doc2 = Document()
            ShipmentConfirmRequest = doc2.createElement("ShipmentConfirmRequest")
            doc2.appendChild(ShipmentConfirmRequest)

            Request = doc2.createElement("Request")
            ShipmentConfirmRequest.appendChild(Request)

            RequestAction = doc2.createElement("RequestAction")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Request"]["RequestAction"])
            RequestAction.appendChild(ptext)
            Request.appendChild(RequestAction)

            RequestOption = doc2.createElement("RequestOption")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Request"]["RequestOption"])
            RequestOption.appendChild(ptext)
            Request.appendChild(RequestOption)

            TransactionReference = doc2.createElement("TransactionReference")
            Request.appendChild(TransactionReference)

            CustomerContext = doc2.createElement("CustomerContext")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Request"]["TransactionReference"]['CustomerContext'])
            CustomerContext.appendChild(ptext)
            TransactionReference.appendChild(CustomerContext)

            Shipment = doc2.createElement("Shipment")
            ShipmentConfirmRequest.appendChild(Shipment)

            Description = doc2.createElement("Description")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Description"])
            Description.appendChild(ptext)
            Shipment.appendChild(Description)
            if package_obj.pick_id.with_ret_service:
                ReturnService = doc2.createElement("ReturnService")
                Shipment.appendChild(ReturnService)


                Code = doc2.createElement("Code")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ReturnService"]["Code"])
                Code.appendChild(ptext)
                ReturnService.appendChild(Code)

            Shipper = doc2.createElement("Shipper")
            Shipment.appendChild(Shipper)

            Name = doc2.createElement("Name")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["Name"])
            Name.appendChild(ptext)
            Shipper.appendChild(Name)

            AttentionName = doc2.createElement("AttentionName")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["AttentionName"])
            AttentionName.appendChild(ptext)
            Shipper.appendChild(AttentionName)

            ShipperNumber = doc2.createElement("ShipperNumber")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["ShipperNumber"])
            ShipperNumber.appendChild(ptext)
            Shipper.appendChild(ShipperNumber)

            TaxIdentificationNumber = doc2.createElement("TaxIdentificationNumber")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["TaxIdentificationNumber"])
            TaxIdentificationNumber.appendChild(ptext)
            Shipper.appendChild(TaxIdentificationNumber)
            PhoneNumber = doc2.createElement("PhoneNumber")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["PhoneNumber"])
            PhoneNumber.appendChild(ptext)
            Shipper.appendChild(PhoneNumber)

            FaxNumber = doc2.createElement("FaxNumber")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["FaxNumber"])
            FaxNumber.appendChild(ptext)
            Shipper.appendChild(FaxNumber)

            EMailAddress = doc2.createElement("EMailAddress")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["EMailAddress"])
            EMailAddress.appendChild(ptext)
            Shipper.appendChild(EMailAddress)

            #################address
            Address = doc2.createElement("Address")
            Shipper.appendChild(Address)

            AddressLine1 = doc2.createElement("AddressLine1")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["Address"]["AddressLine1"])
            AddressLine1.appendChild(ptext)
            Address.appendChild(AddressLine1)

            AddressLine2 = doc2.createElement("AddressLine2")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["Address"]["AddressLine2"])
            AddressLine2.appendChild(ptext)
            Address.appendChild(AddressLine2)

            AddressLine3 = doc2.createElement("AddressLine3")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["Address"]["AddressLine3"])
            AddressLine3.appendChild(ptext)
            Address.appendChild(AddressLine3)

            City = doc2.createElement("City")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["Address"]["City"])
            City.appendChild(ptext)
            Address.appendChild(City)

            StateProvinceCode = doc2.createElement("StateProvinceCode")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["Address"]["StateProvinceCode"])
            StateProvinceCode.appendChild(ptext)
            Address.appendChild(StateProvinceCode)

            PostalCode = doc2.createElement("PostalCode")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["Address"]["PostalCode"])
            PostalCode.appendChild(ptext)
            Address.appendChild(PostalCode)
            CountryCode = doc2.createElement("CountryCode")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Shipper"]["Address"]["CountryCode"])
            CountryCode.appendChild(ptext)
            Address.appendChild(CountryCode)

            ShipTo = doc2.createElement("ShipTo")
            Shipment.appendChild(ShipTo)
            CompanyName = doc2.createElement("CompanyName")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["CompanyName"])
            CompanyName.appendChild(ptext)
            ShipTo.appendChild(CompanyName)

            AttentionName = doc2.createElement("AttentionName")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["AttentionName"])
            AttentionName.appendChild(ptext)
            ShipTo.appendChild(AttentionName)

            TaxIdentificationNumber = doc2.createElement("TaxIdentificationNumber")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["TaxIdentificationNumber"])
            TaxIdentificationNumber.appendChild(ptext)
            ShipTo.appendChild(TaxIdentificationNumber)

            PhoneNumber = doc2.createElement("PhoneNumber")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["PhoneNumber"])
            PhoneNumber.appendChild(ptext)
            ShipTo.appendChild(PhoneNumber)

            FaxNumber = doc2.createElement("FaxNumber")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["FaxNumber"])
            FaxNumber.appendChild(ptext)
            ShipTo.appendChild(FaxNumber)

            EMailAddress = doc2.createElement("EMailAddress")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["EMailAddress"])
            EMailAddress.appendChild(ptext)
            ShipTo.appendChild(EMailAddress)

            LocationID = doc2.createElement("LocationID")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["LocationID"])
            LocationID.appendChild(ptext)
            ShipTo.appendChild(LocationID)

            Address = doc2.createElement("Address")
            ShipTo.appendChild(Address)
            AddressLine1 = doc2.createElement("AddressLine1")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["Address"]["AddressLine1"])
            AddressLine1.appendChild(ptext)
            Address.appendChild(AddressLine1)

            AddressLine2 = doc2.createElement("AddressLine2")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["Address"]["AddressLine2"])
            AddressLine2.appendChild(ptext)
            Address.appendChild(AddressLine2)

            AddressLine2 = doc2.createElement("AddressLine3")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["Address"]["AddressLine3"])
            AddressLine3.appendChild(ptext)
            Address.appendChild(AddressLine3)

            City = doc2.createElement("City")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["Address"]["City"])
            City.appendChild(ptext)
            Address.appendChild(City)

            StateProvinceCode = doc2.createElement("StateProvinceCode")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["Address"]["StateProvinceCode"])
            StateProvinceCode.appendChild(ptext)
            Address.appendChild(StateProvinceCode)

            PostalCode = doc2.createElement("PostalCode")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["Address"]["PostalCode"])
            PostalCode.appendChild(ptext)
            Address.appendChild(PostalCode)

            CountryCode = doc2.createElement("CountryCode")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipTo"]["Address"]["CountryCode"])
            CountryCode.appendChild(ptext)
            Address.appendChild(CountryCode)
            if package_obj.pick_id.ship_from:
                ShipFrom = doc2.createElement("ShipFrom")
                Shipment.appendChild(ShipFrom)
                CompanyName = doc2.createElement("CompanyName")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipFrom"]["CompanyName"])
                CompanyName.appendChild(ptext)
                ShipFrom.appendChild(CompanyName)

                AttentionName = doc2.createElement("AttentionName")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipFrom"]["AttentionName"])
                AttentionName.appendChild(ptext)
                ShipFrom.appendChild(AttentionName)

                TaxIdentificationNumber = doc2.createElement("TaxIdentificationNumber")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipFrom"]["TaxIdentificationNumber"])
                TaxIdentificationNumber.appendChild(ptext)
                ShipFrom.appendChild(TaxIdentificationNumber)

                PhoneNumber = doc2.createElement("PhoneNumber")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipFrom"]["PhoneNumber"])
                PhoneNumber.appendChild(ptext)
                ShipFrom.appendChild(PhoneNumber)

                FaxNumber = doc2.createElement("FaxNumber")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipFrom"]["FaxNumber"])
                FaxNumber.appendChild(ptext)
                ShipFrom.appendChild(FaxNumber)

                Address = doc2.createElement("Address")
                ShipFrom.appendChild(Address)
                AddressLine1 = doc2.createElement("AddressLine1")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipFrom"]["Address"]["AddressLine1"])
                AddressLine1.appendChild(ptext)
                Address.appendChild(AddressLine1)

                AddressLine2 = doc2.createElement("AddressLine2")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipFrom"]["Address"]["AddressLine2"])
                AddressLine2.appendChild(ptext)
                Address.appendChild(AddressLine2)

                AddressLine3 = doc2.createElement("AddressLine3")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipFrom"]["Address"]["AddressLine3"])
                AddressLine3.appendChild(ptext)
                Address.appendChild(AddressLine3)

                City = doc2.createElement("City")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipFrom"]["Address"]["City"])
                City.appendChild(ptext)
                Address.appendChild(City)

                StateProvinceCode = doc2.createElement("StateProvinceCode")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipFrom"]["Address"]["StateProvinceCode"])
                StateProvinceCode.appendChild(ptext)
                Address.appendChild(StateProvinceCode)

                CountryCode = doc2.createElement("CountryCode")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipFrom"]["Address"]["CountryCode"])
                CountryCode.appendChild(ptext)
                Address.appendChild(CountryCode)


            if comm_inv or nafta_cer_orig:
                SoldTo = doc2.createElement("SoldTo")
                Shipment.appendChild(SoldTo)
                Option = doc2.createElement("Option")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["Option"])
                Option.appendChild(ptext)
                SoldTo.appendChild(Option)
                
                CompanyName = doc2.createElement("CompanyName")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["CompanyName"])
                CompanyName.appendChild(ptext)
                SoldTo.appendChild(CompanyName)
#                else:  
                CompanyName = doc2.createElement("CompanyName")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["CompanyName"])
                CompanyName.appendChild(ptext)
                SoldTo.appendChild(CompanyName)
    
                AttentionName = doc2.createElement("AttentionName")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["AttentionName"])
                AttentionName.appendChild(ptext)
                SoldTo.appendChild(AttentionName)
    
                TaxIdentificationNumber = doc2.createElement("TaxIdentificationNumber")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["TaxIdentificationNumber"])
                TaxIdentificationNumber.appendChild(ptext)
                SoldTo.appendChild(TaxIdentificationNumber)
    
                PhoneNumber = doc2.createElement("PhoneNumber")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["PhoneNumber"])
                PhoneNumber.appendChild(ptext)
                SoldTo.appendChild(PhoneNumber)
    
    
                Address = doc2.createElement("Address")
                SoldTo.appendChild(Address)
                AddressLine1 = doc2.createElement("AddressLine1")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["Address"]["AddressLine1"])
                AddressLine1.appendChild(ptext)
                Address.appendChild(AddressLine1)
    
                AddressLine2 = doc2.createElement("AddressLine2")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["Address"]["AddressLine2"])
                AddressLine2.appendChild(ptext)
                Address.appendChild(AddressLine2)
    
    
                City = doc2.createElement("City")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["Address"]["City"])
                City.appendChild(ptext)
                Address.appendChild(City)
    
                StateProvinceCode = doc2.createElement("StateProvinceCode")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["Address"]["StateProvinceCode"])
                StateProvinceCode.appendChild(ptext)
                Address.appendChild(StateProvinceCode)
    
                PostalCode = doc2.createElement("PostalCode")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["Address"]["PostalCode"])
                PostalCode.appendChild(ptext)
                Address.appendChild(PostalCode)
    
                CountryCode = doc2.createElement("CountryCode")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["SoldTo"]["Address"]["CountryCode"])
                CountryCode.appendChild(ptext)
                Address.appendChild(CountryCode)

            PaymentInformation = doc2.createElement("PaymentInformation")
            Shipment.appendChild(PaymentInformation)
            Prepaid = doc2.createElement("Prepaid")
            PaymentInformation.appendChild(Prepaid)

            BillShipper = doc2.createElement("BillShipper")
            Prepaid.appendChild(BillShipper)

            AccountNumber = doc2.createElement("AccountNumber")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["PaymentInformation"]["Prepaid"]["BillShipper"]["AccountNumber"])
            AccountNumber.appendChild(ptext)
            BillShipper.appendChild(AccountNumber)


            GoodsNotInFreeCirculationIndicator = doc2.createElement("GoodsNotInFreeCirculationIndicator")
            Shipment.appendChild(GoodsNotInFreeCirculationIndicator)

            RateInformation = doc2.createElement("RateInformation")
            Shipment.appendChild(RateInformation)
            NegotiatedRatesIndicator = doc2.createElement("NegotiatedRatesIndicator")
            RateInformation.appendChild(NegotiatedRatesIndicator)

            Service = doc2.createElement("Service")
            Shipment.appendChild(Service)
            Code = doc2.createElement("Code")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Service"]["Code"])
            Code.appendChild(ptext)
            Service.appendChild(Code)
            Description = doc2.createElement("Description")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Service"]["Description"])
            Description.appendChild(ptext)
            Service.appendChild(Description)

            if (package_obj.pick_id.ship_from and package_obj.pick_id.ship_from_address.id and package_obj.pick_id.ship_from_address.country_id.code == 'US' or package_obj.pick_id.shipper.id and package_obj.pick_id.shipper.address.id and package_obj.pick_id.shipper.address.country_id.id and package_obj.pick_id.shipper.address.country_id.code == 'US') and  package_obj.pick_id.address_id.id and package_obj.pick_id.address_id.country_id.code in ('PR','CA'):
                InvoiceLineTotal = doc2.createElement("InvoiceLineTotal")
                Shipment.appendChild(InvoiceLineTotal)

                MonetaryValue = doc2.createElement("MonetaryValue")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["InvoiceLineTotal"]["MonetaryValue"])
                MonetaryValue.appendChild(ptext)
                InvoiceLineTotal.appendChild(MonetaryValue)

            if package_obj.pick_id.sat_delivery:
                SaturdayDelivery = doc2.createElement("SaturdayDelivery")
                ShipmentServiceOptions.appendChild(SaturdayDelivery)

            Notification_count = len(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["Notification"])
            for i in range (0,Notification_count):
                Notification = doc2.createElement("Notification")
                ShipmentServiceOptions.appendChild(Notification)
                NotificationCode = doc2.createElement("NotificationCode")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["Notification"][i]["NotificationCode"])
                NotificationCode.appendChild(ptext)
                Notification.appendChild(NotificationCode)
                EMailMessage = doc2.createElement("EMailMessage")
                Notification.appendChild(EMailMessage)
                UndeliverableEMailAddress = doc2.createElement("UndeliverableEMailAddress")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["Notification"][i]["EMailMessage"]["UndeliverableEMailAddress"])
                UndeliverableEMailAddress.appendChild(ptext)
                EMailMessage.appendChild(UndeliverableEMailAddress)

                EMailAddress = doc2.createElement("EMailAddress")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["Notification"][i]["EMailMessage"]["EMailAddress"])
                EMailAddress.appendChild(ptext)
                EMailMessage.appendChild(EMailAddress)

                FromEMailAddress = doc2.createElement("FromEMailAddress")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["Notification"][i]["EMailMessage"]["FromEMailAddress"])
                FromEMailAddress.appendChild(ptext)
                EMailMessage.appendChild(FromEMailAddress)

                FromName = doc2.createElement("FromName")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["Notification"][i]["EMailMessage"]["FromName"])
                FromName.appendChild(ptext)
                EMailMessage.appendChild(FromName)

                Memo = doc2.createElement("Memo")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["Notification"][i]["EMailMessage"]["Memo"])
                Memo.appendChild(ptext)
                EMailMessage.appendChild(Memo)

                Subject = doc2.createElement("Subject")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["Notification"][i]["EMailMessage"]["Subject"])
                Subject.appendChild(ptext)
                EMailMessage.appendChild(Subject)

                SubjectCode = doc2.createElement("SubjectCode")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["ShipmentServiceOptions"]["Notification"][i]["EMailMessage"]["SubjectCode"])
                SubjectCode.appendChild(ptext)
                EMailMessage.appendChild(SubjectCode)
            ##//////////////////////end for loop in code
            if package_obj.pick_id.with_ret_service:
                LabelDelivery = doc2.createElement("LabelDelivery")
                ShipmentServiceOptions.appendChild(LabelDelivery)
                LabelLinkIndicator = doc2.createElement("LabelLinkIndicator")
                LabelDelivery.appendChild(LabelLinkIndicator)
            
            if comm_inv or cer_orig or nafta_cer_orig or sed:
                InternationalForms = doc2.createElement("InternationalForms")
                ShipmentServiceOptions.appendChild(InternationalForms)
                
            if comm_inv:
                FormType = doc2.createElement("FormType")
                ptext = doc1.createTextNode(comm_inv['FormType'])
                FormType.appendChild(ptext)
                InternationalForms.appendChild(FormType)
            if cer_orig:
                FormType = doc2.createElement("FormType")
                ptext = doc1.createTextNode(cer_orig['FormType'])
                FormType.appendChild(ptext)
                InternationalForms.appendChild(FormType)
            if nafta_cer_orig:
                FormType = doc2.createElement("FormType")
                ptext = doc1.createTextNode(nafta_cer_orig['FormType'])
                FormType.appendChild(ptext)
                InternationalForms.appendChild(FormType)
                
            if sed or nafta_cer_orig:
                Contacts = doc2.createElement("Contacts")
                InternationalForms.appendChild(Contacts)
                if nafta_cer_orig and nafta_cer_orig["Contacts"].get("Producer"):
                    Producer = doc2.createElement("Producer")
                    Contacts.appendChild(Producer)
                    if nafta_cer_orig["Contacts"]['Producer'].get('Option') != ' ':
                        Option = doc2.createElement("Option")
                        ptext = doc1.createTextNode(nafta_cer_orig["Contacts"]['Producer']['Option'])
                        Option.appendChild(ptext)
                        Producer.appendChild(Option)
                    else:
                        CompanyName = doc2.createElement("CompanyName")
                        ptext = doc1.createTextNode(nafta_cer_orig["Contacts"]['Producer']['CompanyName'])
                        CompanyName.appendChild(ptext)
                        Producer.appendChild(CompanyName)
                
                        TaxIdentificationNumber = doc2.createElement("TaxIdentificationNumber")
                        ptext = doc1.createTextNode(nafta_cer_orig["Contacts"]['Producer']['TaxIdentificationNumber'])
                        TaxIdentificationNumber.appendChild(ptext)
                        Producer.appendChild(TaxIdentificationNumber)
                
                        Address = doc2.createElement("Address")
                        Producer.appendChild(Address)
                
                        AddressLine1 = doc2.createElement("AddressLine1")
                        ptext = doc1.createTextNode(nafta_cer_orig["Contacts"]['Producer']['Address']['AddressLine1'])
                        AddressLine1.appendChild(ptext)
                        Address.appendChild(AddressLine1)
                
                        AddressLine2 = doc2.createElement("AddressLine2")
                        ptext = doc1.createTextNode(nafta_cer_orig["Contacts"]['Producer']['Address']['AddressLine2'])
                        AddressLine2.appendChild(ptext)
                        Address.appendChild(AddressLine2)
                
                        City = doc2.createElement("City")
                        ptext = doc1.createTextNode(nafta_cer_orig["Contacts"]['Producer']['Address']['City'])
                        City.appendChild(ptext)
                        Address.appendChild(City)
                
                        StateProvinceCode = doc2.createElement("StateProvinceCode")
                        ptext = doc1.createTextNode(nafta_cer_orig["Contacts"]['Producer']['Address']['StateProvinceCode'])
                        StateProvinceCode.appendChild(ptext)
                        Address.appendChild(StateProvinceCode)
                
                        PostalCode = doc2.createElement("PostalCode")
                        ptext = doc1.createTextNode(nafta_cer_orig["Contacts"]['Producer']['Address']['PostalCode'])
                        PostalCode.appendChild(ptext)
                        Address.appendChild(PostalCode)
                
                        CountryCode = doc2.createElement("CountryCode")
                        ptext = doc1.createTextNode(nafta_cer_orig["Contacts"]['Producer']['Address']['CountryCode'])
                        CountryCode.appendChild(ptext)
                        Address.appendChild(CountryCode)
            
            Product_count = len(prod) > 50 and 50 or len(prod)
            if comm_inv or cer_orig or nafta_cer_orig or sed:
                for i in range (0,Product_count):
       
                    Product = doc2.createElement("Product")
                    InternationalForms.appendChild(Product)
        
                    Description = doc2.createElement("Description")
                    ptext = doc1.createTextNode(prod[i]['Description'])
                    Description.appendChild(ptext)
                    Product.appendChild(Description)
                    if comm_inv:
                        Unit = doc2.createElement("Unit")
                        Product.appendChild(Unit)
                        Number = doc2.createElement("Number")
                        ptext = doc1.createTextNode(prod[i]['Unit']['Number'])
                        Number.appendChild(ptext)
                        Unit.appendChild(Number)
            
                        Value = doc2.createElement("Value")
                        ptext = doc1.createTextNode(prod[i]['Unit']['Value'])
                        Value.appendChild(ptext)
                        Unit.appendChild(Value)
        
                        UnitOfMeasurement = doc2.createElement("UnitOfMeasurement")
                        Unit.appendChild(UnitOfMeasurement)
                        Code = doc2.createElement("Code")
                        ptext = doc1.createTextNode(prod[i]['Unit']['UnitOfMeasurement']['Code'])
                        Code.appendChild(ptext)
                        UnitOfMeasurement.appendChild(Code)
        
                        Description = doc2.createElement("Description")
                        ptext = doc1.createTextNode(prod[i]['Unit']['UnitOfMeasurement']['Description'])
                        Description.appendChild(ptext)
                        UnitOfMeasurement.appendChild(Description)
                    if nafta_cer_orig or comm_inv:
                        CommodityCode = doc2.createElement("CommodityCode")
                        ptext = doc1.createTextNode(prod[i]['CommodityCode'])
                        CommodityCode.appendChild(ptext)
                        Product.appendChild(CommodityCode)
                    if nafta_cer_orig or comm_inv or cer_orig:
                        OriginCountryCode = doc2.createElement("OriginCountryCode")
                        ptext = doc1.createTextNode(prod[i]['OriginCountryCode'])
                        OriginCountryCode.appendChild(ptext)
                        Product.appendChild(OriginCountryCode)
                    if nafta_cer_orig:
            
                        NetCostCode = doc2.createElement("NetCostCode")
                        ptext = doc1.createTextNode(prod[i]['NetCostCode'])
                        NetCostCode.appendChild(ptext)
                        Product.appendChild(NetCostCode)
            
            
                        PreferenceCriteria = doc2.createElement("PreferenceCriteria")
                        ptext = doc1.createTextNode(prod[i]['PreferenceCriteria'])
                        PreferenceCriteria.appendChild(ptext)
                        Product.appendChild(PreferenceCriteria)

                        
                        ProducerInfo = doc2.createElement("ProducerInfo")
                        ptext = doc1.createTextNode(prod[i]['ProducerInfo'])
                        ProducerInfo.appendChild(ptext)
                        Product.appendChild(ProducerInfo)
                    if cer_orig:
        
                        NumberOfPackagesPerCommodity = doc2.createElement("NumberOfPackagesPerCommodity")
                        ptext = doc1.createTextNode(prod[i]['NumberOfPackagesPerCommodity'])
                        NumberOfPackagesPerCommodity.appendChild(ptext)
                        Product.appendChild(NumberOfPackagesPerCommodity)
        
        
                        ProductWeight = doc2.createElement("ProductWeight")
                        Product.appendChild(ProductWeight)
                        UnitOfMeasurement = doc2.createElement("UnitOfMeasurement")
                        ProductWeight.appendChild(UnitOfMeasurement)
                        Code = doc2.createElement("Code")
                        ptext = doc1.createTextNode(prod[i]['ProductWeight']['UnitOfMeasurement']['Code'])
                        Code.appendChild(ptext)
                        UnitOfMeasurement.appendChild(Code)
            
                        Description = doc2.createElement("Description")
                        ptext = doc1.createTextNode(prod[i]['ProductWeight']['UnitOfMeasurement']['Description'])
                        Description.appendChild(ptext)
                        UnitOfMeasurement.appendChild(Description)
            
                        Weight = doc2.createElement("Weight")
                        ptext = doc1.createTextNode(prod[i]['ProductWeight']['Weight'])
                        Weight.appendChild(ptext)
                        ProductWeight.appendChild(Weight)
                #/////////end loop in code
        
        
                if comm_inv:
                    if comm_inv.get("InvoiceDate"):
                        InvoiceDate = doc2.createElement("InvoiceDate")
                        ptext = doc1.createTextNode(comm_inv["InvoiceDate"])
                        InvoiceDate.appendChild(ptext)
                        InternationalForms.appendChild(InvoiceDate)
                    ReasonForExport = doc2.createElement("ReasonForExport")
                    ptext = doc1.createTextNode(comm_inv["ReasonForExport"])
                    ReasonForExport.appendChild(ptext)
                    InternationalForms.appendChild(ReasonForExport)

                    DeclarationStatement = doc2.createElement("DeclarationStatement")
                    ptext = doc1.createTextNode(comm_inv["DeclarationStatement"])
                    DeclarationStatement.appendChild(ptext)
                    InternationalForms.appendChild(DeclarationStatement)
       
                    CurrencyCode = doc2.createElement("CurrencyCode")
                    ptext = doc1.createTextNode(comm_inv["CurrencyCode"])
                    CurrencyCode.appendChild(ptext)
                    InternationalForms.appendChild(CurrencyCode)
                if nafta_cer_orig and nafta_cer_orig.get('BlanketPeriod'):
                    BlanketPeriod = doc2.createElement("BlanketPeriod")
                    InternationalForms.appendChild(BlanketPeriod)
                    
                    BeginDate = doc2.createElement("BeginDate")
                    ptext = doc1.createTextNode(nafta_cer_orig['BlanketPeriod']["BeginDate"])
                    BeginDate.appendChild(ptext)
                    BlanketPeriod.appendChild(BeginDate)
            
                    EndDate = doc2.createElement("EndDate")
                    ptext = doc1.createTextNode(nafta_cer_orig['BlanketPeriod']["EndDate"])
                    EndDate.appendChild(ptext)
                    BlanketPeriod.appendChild(EndDate)
                if cer_orig or sed:
                    ExportDate = doc2.createElement("ExportDate")
                    ptext = doc1.createTextNode(cer_orig['ExportDate'])
                    ExportDate.appendChild(ptext)
                    InternationalForms.appendChild(ExportDate)
            
                    ExportingCarrier = doc2.createElement("ExportingCarrier")
                    ptext = doc1.createTextNode(cer_orig['ExportingCarrier'])
                    ExportingCarrier.appendChild(ptext)
                    InternationalForms.appendChild(ExportingCarrier)

            Package_count = len(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"])
            for i in range(0,Package_count):
                Package = doc2.createElement("Package")
                Shipment.appendChild(Package)

                Description = doc2.createElement("Description")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]["Description"])
                Description.appendChild(ptext)
                Package.appendChild(Description)
                PackagingType = doc2.createElement("PackagingType")
                Package.appendChild(PackagingType)

                Code = doc2.createElement("Code")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]["PackagingType"]['Code'])
                Code.appendChild(ptext)
                PackagingType.appendChild(Code)
                Description = doc2.createElement("Description")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]["PackagingType"]['Description'])
                Description.appendChild(ptext)
                PackagingType.appendChild(Description)

                Dimensions = doc2.createElement("Dimensions")
                Package.appendChild(Dimensions)

                Length = doc2.createElement("Length")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]["Dimensions"]["Length"])
                Length.appendChild(ptext)
                Dimensions.appendChild(Length)
                Width = doc2.createElement("Width")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]["Dimensions"]["Width"])
                Width.appendChild(ptext)
                Dimensions.appendChild(Width)
                Height = doc2.createElement("Height")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]["Dimensions"]["Height"])
                Height.appendChild(ptext)
                Dimensions.appendChild(Height)
                UnitOfMeasurement = doc2.createElement("UnitOfMeasurement")
                Dimensions.appendChild(UnitOfMeasurement)

                Code = doc2.createElement("Code")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]["Dimensions"]['UnitOfMeasurement']["Code"])
                Code.appendChild(ptext)
                UnitOfMeasurement.appendChild(Code)
                Description = doc2.createElement("Description")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]["Dimensions"]['UnitOfMeasurement']["Description"])
                Description.appendChild(ptext)
                UnitOfMeasurement.appendChild(Description)


                PackageWeight = doc2.createElement("PackageWeight")
                Package.appendChild(PackageWeight)

                UnitOfMeasurement = doc2.createElement("UnitOfMeasurement")
                PackageWeight.appendChild(UnitOfMeasurement)
                Code = doc2.createElement("Code")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]['PackageWeight']['UnitOfMeasurement']["Code"])
                Code.appendChild(ptext)
                UnitOfMeasurement.appendChild(Code)

                Description = doc2.createElement("Description")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]['PackageWeight']['UnitOfMeasurement']["Description"])
                Description.appendChild(ptext)
                UnitOfMeasurement.appendChild(Description)

                Weight = doc2.createElement("Weight")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]['PackageWeight']["Weight"])
                Weight.appendChild(ptext)
                PackageWeight.appendChild(Weight)
                
                """     <PackageServiceOptions>
                            <InsuredValue>
                                <CurrencyCode>USD</CurrencyCode>
                                <MonetaryValue>1000</MonetaryValue>
                            </InsuredValue>
                       </PackageServiceOptions>
                       
                    """
                PackageServiceOptions = doc2.createElement("PackageServiceOptions")
                
                
                InsuredValue = doc2.createElement("InsuredValue")
                
                CurrencyCode = doc2.createElement("CurrencyCode")
                ptext = doc1.createTextNode('USD')
                CurrencyCode.appendChild(ptext)
                
                MonetaryValue = doc2.createElement("MonetaryValue")
                ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["Shipment"]["Package"][i]["PackageServiceOptions"]['InsuredValue']['MonetaryValue'])
                MonetaryValue.appendChild(ptext)
                
                
                InsuredValue.appendChild(CurrencyCode)
                InsuredValue.appendChild(MonetaryValue)
                
                PackageServiceOptions.appendChild(InsuredValue)
                
                Package.appendChild(PackageServiceOptions)
               
                #/////////end loop in code

            LabelSpecification = doc2.createElement("LabelSpecification")
            ShipmentConfirmRequest.appendChild(LabelSpecification)

            LabelPrintMethod = doc2.createElement("LabelPrintMethod")
            LabelSpecification.appendChild(LabelPrintMethod)
            Code = doc2.createElement("Code")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["LabelSpecification"]["LabelPrintMethod"]["Code"])
            Code.appendChild(ptext)
            LabelPrintMethod.appendChild(Code)

            Description = doc2.createElement("Description")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["LabelSpecification"]["LabelPrintMethod"]["Description"])
            Description.appendChild(ptext)
            LabelPrintMethod.appendChild(Description)

            LabelStockSize = doc2.createElement("LabelStockSize")
            LabelSpecification.appendChild(LabelStockSize)
            Height = doc2.createElement("Height")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["LabelSpecification"]["LabelStockSize"]["Height"])
            Height.appendChild(ptext)
            LabelStockSize.appendChild(Height)
            Width = doc2.createElement("Width")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["LabelSpecification"]["LabelStockSize"]["Width"])
            Width.appendChild(ptext)
            LabelStockSize.appendChild(Width)

            LabelImageFormat = doc2.createElement("LabelImageFormat")
            LabelSpecification.appendChild(LabelImageFormat)

            Code = doc2.createElement("Code")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["LabelSpecification"]["LabelImageFormat"]["Code"])
            Code.appendChild(ptext)
            LabelImageFormat.appendChild(Code)

            Description = doc2.createElement("Description")
            ptext = doc1.createTextNode(data_for_confirm_request["ShipmentConfirmRequest"]["LabelSpecification"]["LabelImageFormat"]["Description"])
            Description.appendChild(ptext)
            LabelImageFormat.appendChild(Description)

            request_string2=doc2.toprettyxml()

            request_string=Request_string1+request_string2

            return request_string


    def get_value(self, cr, uid, object, message=None, context=None):

        if message is None:
            message = {}
        #Returns the computed expression
        if message:
            try:
                from mako.template import Template as MakoTemplate
                message = tools.ustr(message)
               
                env = {
                    'user':self.pool.get('res.users').browse(cr, uid, uid, context=context),
                    'db':cr.dbname
                       }
                templ = MakoTemplate(message, input_encoding='utf-8')
                reply = MakoTemplate(message).render_unicode( object=object,
                                                             peobject=object,
                                                             env=env,
                                                             format_exceptions=True)
                
                return reply or False
            except Exception:
                logging.exception("Can't render %r", message)
                return u""
        else:
            return message
            


    def process_ship(self,cr, uid, ids, context=None):
        deliv_order = self.browse(cr, uid, type(ids)==type([]) and ids[0] or ids, context=context)
        if deliv_order.ship_company_code != 'ups':
            return super(stock_picking, self).process_ship(cr, uid, ids, context=context)
        error_flag=False
        ship_move_ids={}
        do_transaction = True
        response_dic = {}
        if not (deliv_order.logis_company or deliv_order.shipper or deliv_order.ups_service):
            raise osv.except_osv("Warning", "Please select Logistics Company, Shipper and Shipping Service")
        if not deliv_order.packages_ids:
            raise osv.except_osv("Warning", "Please add shipping packages before doing Process Shipping.")
        if not deliv_order.invoiced and deliv_order.sale_id and deliv_order.sale_id.order_policy == 'credit_card' :
            if not deliv_order.sale_id.cc_pre_auth:
                raise osv.except_osv("Warning", "The sales order is not paid")
            else:
                do_transaction = False
                rel_voucher_id = deliv_order.sale_id.rel_account_voucher_id
                if rel_voucher_id and rel_voucher_id.state != 'posted' and deliv_order.sale_id.cc_pre_auth:
                    self.pool.get('account.voucher').write(cr,uid,[rel_voucher_id.id],{'cc_p_authorize':False,'cc_charge':True}, context=context)
                    do_transaction = self.pool.get('account.voucher').authorize(cr, uid, [rel_voucher_id.id], context=context)
            if  not do_transaction:
                self.write(cr,uid,ids,{'ship_state':'hold','ship_message':'Unable to process creditcard payment.'})
                cr.commit()
                raise osv.except_osv(_('Final credit card charge cannot be completed!'),_("Please hold shipment and contact customer service..") )
        warning_error = False
        for pack_obj in deliv_order.packages_ids:
            ship_confirm_request_xml=self.create_ship_confirm_request(cr, uid,pack_obj.id)
            
            ship_confirm_web=''
            ship_confirm_port=''

            if deliv_order.logis_company:
                if deliv_order.logis_company.test_mode:
                    ship_confirm_web=deliv_order.logis_company.ship_req_test_web
                    ship_confirm_port=deliv_order.logis_company.ship_req_test_port

                else:
                    ship_confirm_web=deliv_order.logis_company.ship_req_web
                    ship_confirm_port=deliv_order.logis_company.ship_req_port

                if ship_confirm_web:
                    parse_url = urlparse(ship_confirm_web)
                    serv = parse_url.netloc
                    serv_path = parse_url.path
                else:
                    raise osv.except_osv(_('Unable to find Shipping URL!'),_("Please configure the shipping company with websites."))

                conn=httplib.HTTPSConnection(serv,ship_confirm_port)
                filename="/tmp/ship_confirm_request_" + deliv_order.name.replace('/','') + '.xml'
                f = open(filename, 'w')
                f.write(ship_confirm_request_xml)
                f.close
                res=conn.request("POST",serv_path,ship_confirm_request_xml)
                """1.make and call function to send request/ 2.make function to process the response and write it """


                res=conn.getresponse()
                result = res.read()
                filename= "/tmp/ship_confirm_response_" + deliv_order.name.replace('/','') + '.xml'
                
                f = open(filename, 'w')
                f.write(result)
                f.close
                response_dic=xml2dic.main(result)

                response = ''
                
            if not response_dic:
                continue
            for res_elm in  response_dic['ShipmentConfirmResponse'][0]['Response']:
                if res_elm.get('ResponseStatusCode'):
                    response = '\nResponse Status Code: '+str(res_elm['ResponseStatusCode'])
                if res_elm.get('ResponseStatusDescription'):
                    response += '\nResponse Description: '+str(res_elm['ResponseStatusDescription'])
                if res_elm.get('Error'):
                    
                    error_flag =True
                    for err_elm in res_elm.get('Error'):
                        if err_elm.get('ErrorSeverity',False):
                            response += '\nErrorSeverity: '+str(err_elm['ErrorSeverity'])
                            if str(err_elm['ErrorSeverity']) == 'Warning':
                                warning_error = True
                                error_flag = False
                        if err_elm.get('ErrorCode',False):
                            response += '\nErrorCode: '+str(err_elm['ErrorCode'])
                        if err_elm.get('ErrorDescription',False):
                            response += '\nErrorDescription: '+str(err_elm['ErrorDescription'])
                        if err_elm.get('ErrorLocation',False):
                            response += '\nErrorLocation: '+str(err_elm['ErrorLocation'])
                    self.write(cr,uid,ids,{'ship_message':'Ship Processing:'+str(response)})
                    if not warning_error:
                        break
            temp=""
            if len(response_dic['ShipmentConfirmResponse'])>5 and response_dic['ShipmentConfirmResponse'][5].has_key('ShipmentDigest') :
                temp +=str(response_dic['ShipmentConfirmResponse'][5]['ShipmentDigest'])
            self.pool.get('stock.packages').write(cr,uid,[pack_obj.id],{'ship_message':str(response),'shipment_digest':str(temp)})


            if int(time.strftime("%w")) in range(1,6) or (time.strftime("%w") == '6' and deliv_order.sat_delivery):
                next_pic_date = time.strftime("%Y-%m-%d")
            else:
                timedelta = datetime.timedelta(7-int(time.strftime("%w")))
                next_pic_date = (datetime.datetime.today()+timedelta).strftime("%Y-%m-%d")

            value_dic={'pick_id':deliv_order.id ,
                       'package_weight':pack_obj.weight,
                       'state':deliv_order.ship_state,
                       'partner_id':deliv_order.address_id.id and deliv_order.address_id.partner_id.id,
                       'service':deliv_order.ups_service.id,
                       'ship_to':deliv_order.address_id.id,
                       'ship_from':deliv_order.ship_from and deliv_order.ship_from_address.id  or deliv_order.shipper.id and deliv_order.shipper.address.id,
                       'package':pack_obj.description and str(pack_obj.description)[:126],
                       'pic_date':next_pic_date,
                       'sale_id':deliv_order.sale_id.id and deliv_order.sale_id.id or False,
                       }
            if not error_flag:
                ship_move_ids[pack_obj.id] = self.pool.get('shipping.move').create(cr, uid, value_dic)
                self.process_ship_accept(cr, uid, ids,ship_move_ids,pack_obj,context=context)
        if not error_flag:
            if warning_error:
                ship_msg = 'Shipping success with warning. Please see the individual package details.'
            else:
                ship_msg = 'Success'
            self.write(cr,uid,ids,{'ship_state':'ready_pick','ship_message':ship_msg})
            try:
                self.send_conf_mail(cr,uid,ids,context=context)
            except Exception,e:
                pass
            if ship_move_ids:
                self.pool.get('shipping.move').write(cr, uid, ship_move_ids.values(),{'state':'ready_pick'})
            return {
                    'type': 'ir.actions.report.xml',
                    'report_name':'multiple.label.print',
                    'datas': {
                            'model':'stock.picking',
                            'id': ids and ids[0] or False,
                            'ids': ids and ids or [],
                            'report_type': 'pdf'
                        },
                    'nodestroy': True
                    }
        return True

    def _get_journal_id(self, cr, uid, ids, context={}):
        journal_obj = self.pool.get('account.journal')
        vals = []
        browse_picking = self.browse(cr, uid, ids, context=context)

        for pick in browse_picking:
            src_usage = pick.move_lines[0].location_id.usage
            dest_usage = pick.move_lines[0].location_dest_id.usage
            type = pick.type
            if type == 'out' and dest_usage == 'supplier':
                journal_type = 'purchase_refund'
            elif type == 'out' and dest_usage == 'customer':
                journal_type = 'sale'
            elif type == 'in' and src_usage == 'supplier':
                journal_type = 'purchase'
            elif type == 'in' and src_usage == 'customer':
                journal_type = 'sale_refund'
            else:
                journal_type = 'sale'

            value = journal_obj.search(cr, uid, [('type', '=',journal_type )])
            for jr_type in journal_obj.browse(cr, uid, value, context=context):
                t1 = jr_type.id,jr_type.name
                if t1 not in vals:
                    vals.append(t1)
        return vals


    def do_partial(self, cr, uid, ids, partial_datas, context=None):
        res = self._get_journal_id(cr, uid, ids, context=context)
        result_partial = super(stock_picking, self).do_partial(cr, uid, ids, partial_datas, context=context)
        if res and res[0]:
            journal_id = res[0][0]
            result = result_partial
            stock_picking_objs = self.browse(cr, uid, ids, context=context)
            for stock_picking_obj in stock_picking_objs:
                if stock_picking_obj.sale_id and stock_picking_obj.sale_id.order_policy == 'picking':
                    pick_id = result_partial[stock_picking_obj.id]['delivered_picking']
                    result = self.action_invoice_create(cr, uid, [pick_id], journal_id, type=None, context=context)       
                    if len(stock_picking_obj.sale_id.invoice_ids)<=1 and result:
                        self.pool.get('account.invoice').write(cr, uid, result.values(),{'ship_method':stock_picking_obj.sale_id.ship_method,
                                                                                         'shipcharge':stock_picking_obj.sale_id.shipcharge,
                                                                                         'sale_account_id' : stock_picking_obj.sale_id.ship_method_id.account_id.id,
                                                                                         'ship_method_id':stock_picking_obj.sale_id.ship_method_id and stock_picking_obj.sale_id.ship_method_id.id,})
                        self.pool.get('account.invoice').button_reset_taxes(cr, uid, result.values(), context=context)
                        
                            
        
        return result_partial
stock_picking()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
