# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import osv, fields

class change_picker(osv.osv_memory):
    """
    Wizard object to change assigned picker
    """
    _name = "change.picker"
    _description = "Change Assigned Picker"
    _rec_name = 'picker'
    _columns = {
        'picker': fields.many2one('res.users', 'Assigned Picker'),
        }
    
    def update_picker(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        data = self.browse(cr, uid, ids[0], context=context)
        if 'active_ids' in context and 'active_model' in context:
            obj = self.pool.get(context['active_model']) 
            obj.write(cr, uid, context['active_ids'], {'assigned_picker': data.picker.id}, context=context)
            if context['active_model'] == 'stock.move':
                for move in obj.browse(cr, uid, context['active_ids'], context=context):
                    move.picking_id.write({'assigned_picker': data.picker.id}, context=context)
        return {}
    
change_picker()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: