# -*- ecoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import fields, osv
import netsvc
import datetime
import time
from tools.translate import _



class location(osv.osv):
    _inherit='stock.location'

    def search(self, cr, uid, args, offset=0, limit=None, order=None,
            context=None, count=False):
        """Returns the stock locations with non zero real stock for the product
         @param self: The object pointer.
         @param ids: ids of the procurement order document
         @param context: standard dictionary
         @return: returns ids of locations if its real stock for the product is non zero
        """
        "Todo:Test in detail. Test for all type of stock moves"
        usage =[]
        for i in args:
            if i[0]=='usage':
                usage.append(i[2])
        
        if context and context.get('filter_by_real_stock',False) and context.get('product_id',False):
            product_id = context['product_id']
            loc_obj=self.pool.get('stock.location')
#            res=super(location, self).search(cr, uid, args=args, offset=offset, limit =11111, order=order,
#                context=context, count=count)
            if len(usage)==1:
                cr.execute("select id from stock_location where id in (select distinct(location_dest_id) from stock_move where product_id in (%s) and state='done') and usage ='%s'"%(product_id,usage[0]))
            else:
                cr.execute("select distinct(location_dest_id) from stock_move where product_id in (%s) and state='done'"%(product_id))
            res = cr.fetchall()
            
            result = [item[0] for item in res]
            
            
            arg=None
            field_names=['stock_real']
            if not result:
                return []
            stock_values=loc_obj._product_value(cr, uid, result, field_names, arg, context=context)
            for loc_id,stock in stock_values.items():
                if not stock.get('stock_real',False):
                    del stock_values[loc_id]
                if stock['stock_real'] < 0.0:
                    del stock_values[loc_id]
            return stock_values.keys()
        else:
            return super(location, self).search(cr, uid, args=args, offset=offset, limit=limit, order=order,
                context=context, count=count)
location()


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

