# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import fields, osv

class product_product(osv.osv):
    _inherit = 'product.product'
    _columns = {
        'multi_location_ids': fields.one2many('stock.multi.location', 'product_id', 'Stock Locations'),
        }
    
    def _check_storage_type(self, cr, uid, ids, context=None):
        product_ids = self.browse(cr, uid, ids, context=context)
        for product_id in product_ids:
            primary = False
            for multi_loc_id in product_id.multi_location_ids:
                if multi_loc_id.storage_type == 'primary' and primary:
                    return False
                elif multi_loc_id.storage_type == 'primary':
                    primary = True
        return True

    _constraints = [
        (_check_storage_type, 'You cannot create more than one multilocation lines with storage type primary.', ['Storage Type'] )
        ]
    
product_product()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: