# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import fields, osv

class replenish_cancel(osv.osv_memory):

    def ok_button_action(self, cr, uid, ids, data, context=None):
        wizard_obj = self.pool.get('replenish.cancel').browse(cr, uid, ids[0], context=context)
        if wizard_obj.de_activate:
            product_obj = self.pool.get('product.product').browse(cr, uid, wizard_obj.product_id.id, context=context)
            replenish_obj = self.pool.get('multilocation.replenish')
            for multi_loc in product_obj.multi_location_ids:
                if multi_loc.storage_type == 'primary':
                    self.pool.get('stock.multi.location').write(cr, uid, multi_loc.id, {'location_active': False}, context=context)
            rep_ids = replenish_obj.search(cr, uid, [('product_name', '=', product_obj.id )])
            replenish_obj.write(cr, uid, rep_ids, {'state': 'cancel'}, context=context)
        return {}

    def cancel_button_action(self, cr, uid, ids, data, context=None):
        return {}

    def _get_product(self, cr, uid, context=None):
        if context is None:
            context = {}
        if 'active_id' in context:
            replenish = self.pool.get('multilocation.replenish').browse(cr, uid, context['active_id'], context=context)
        return replenish.product_name.id

    _name = "replenish.cancel"
    _columns = {
        'product_id': fields.many2one('product.product', 'Product'),
        'de_activate': fields.boolean('Deactivate replenish for this product'),
        }
    _defaults = {
        'de_activate': False,
        'product_id': _get_product
        }
replenish_cancel()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: