# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import osv

class location_remove(osv.osv_memory):
    _name = "location.remove"
        
    def remove_locations(self, cr, uid, ids, context=None):
        location_obj = self.pool.get('stock.multi.location')
        location_ids = location_obj.search(cr, uid, [('storage_type', '!=', 'primary')], context=context)
        for location_id in location_ids:
            real_stock = location_obj.browse(cr, uid, location_id, context=context).qty_available
            virtual_stock = location_obj.browse(cr, uid, location_id, context=context).virtual_available
            if real_stock <= 0 and virtual_stock <= 0:
                location_obj.unlink(cr, uid, location_id, context=context)
        return {'nodestroy': False}

location_remove()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: